#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
	@Author : Mirco Tracolli
	@Version : 0.7
	
"""

import pymunk
import cocos
from math import sqrt,hypot

class Bullet(pymunk.Body):
	
	def __init__(self,args):
		""" 
			layer = scena di cocos
			de = profondit del disegno
			space = ambiente fisico pymunk
			origin = posizione di partenza
			end = punto arrivo
			vel = velocit del proiettile (scalare che moltiplicher il versore)
			type = tipo di oggetto che lo lancia -> type(class).__name__
		"""
		self.player = args['player']
		self.alive = True
		self.layer = args['layer']
		self.space = args['space']
		direction = (args['end'][0]-args['origin'][0],args['end'][1]-args['origin'][1])
		dirmod = hypot(direction[0],direction[1])
		direction = (direction[0]/dirmod,direction[1]/dirmod)
		self.sprite = cocos.sprite.Sprite(args['img'])
		self.layer.add(self.sprite, z = args['depth'], name = str(id(self)))
		
		super(Bullet,self).__init__(1,pymunk.inf)
		self.position = args['origin']
		self.bodyshape = pymunk.Circle(self,4,(0,0))
		self.bodyshape.sensor = True
		self.bodyshape._set_collision_type(1)
		
		self.sprite.position = self.position
		
		self.space.add(self,self.bodyshape)
		self.velocity = ((int(direction[0]*args['vel']),int(direction[1]*args['vel'])))
	
	# Rimuove l'oggetto da una scena
	def remove(self,bullet=None):
		if bullet is not None :
			self.space.remove(bullet.bodyshape,bullet)
			self.layer.remove(str(id(self)))
		elif self.alive :
			self.space.remove(self.bodyshape,self)
			self.layer.remove(str(id(self)))
		self.alive = False
	
	# Rimuove il proiettile dalla scena dopo una collisione
	def callremove(self,bullet):
		self.space.add_post_step_callback(self.remove,bullet)
	
	# Aggiorna lo stato del proiettile
	def update(self):
		self.sprite.position = self.position
		if self.position[0] < 0 or self.position[0] > 1024 or self.position[1] < 0 or self.position[1] > 768 :
			self.remove()
			return(False)
		return(True)
		
	def __str__(self):
		return("I'm a bullet!")
