#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
	@Version : 0.2
"""

import data,bullet,pymunk,pyglet
from cocos.director import director
from player import *
from npc import *
from menu import *
from pyglet.window import key
from sound import *
from levels import *
from cocos.actions import *
from cocos.scenes import *
import pyglet
from pyglet.gl import *
from cocos.layer import *
	
def main():
	pyglet.resource.path.append('data')
	pyglet.resource.reindex()
	font.add_directory('data')
	director.init(1024, 768, caption='Mad Robot', audio_backend='sdl')
	image = pyglet.image.load(pathatlas+'mouse.png')
	cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
	cursor.drawable = True
	director.window.set_mouse_cursor(cursor)
	director.show_FPS = False
	
	music = Sound(pathatlas+'POL-strategic-war-short.wav')
	effects_list = {}
	effects_list['shot'] = pathatlas+'NFF-laser-gun.wav'
	effects = Effects(effects_list)
	
	#--------------------------------------
	# Altro metodo per le variabili globali
	# globals()['LIVEL1']
	#--------------------------------------
	
	# Global Variables
	global LEVEL_1
	global LEVEL_2 
	global LEVEL_3 
	global LEVEL_4
	global LEVEL_5

	global mainScene
	global scene_1
	global scene_2 
	global scene_3 
	global scene_4
	global scene_5
	
	scene_1 = Scene()
	scene_2 = Scene()
	scene_3 = Scene()
	scene_4 = Scene()
	scene_5 = Scene()
	pause_scene = Scene()
	end_game = Scene()
	mainScene = Scene()
	
	argsLevel = {
		'effects' : effects,
		'pauseScene' : pause_scene,
		'nextLevel' : scene_2,
		'currentLevel' : scene_1,
		'mainScene' : mainScene,
		'theend' : end_game
	} 
	LEVEL_1 = Level_1(argsLevel)
	argsLevel['currentLevel'] = argsLevel['nextLevel']
	argsLevel['nextLevel'] = scene_3
	LEVEL_2 = Level_2(argsLevel)
	argsLevel['currentLevel'] = argsLevel['nextLevel']
	argsLevel['nextLevel'] = scene_4
	LEVEL_3 = Level_3(argsLevel)
	argsLevel['currentLevel'] = argsLevel['nextLevel']
	argsLevel['nextLevel'] = scene_5
	LEVEL_4 = Level_4(argsLevel)
	argsLevel['currentLevel'] = argsLevel['nextLevel']
	argsLevel['nextLevel'] = end_game
	LEVEL_5 = Level_5(argsLevel,True)
	
	mainScene.add(Background(), z=0)
	
	scene_1.add(LEVEL_1)
	scene_2.add(LEVEL_2)
	scene_3.add(LEVEL_3)
	scene_4.add(LEVEL_4)
	scene_5.add(LEVEL_5)
	
	mainScene.add(MultiplexLayer(MainMenu(music,{'scene_1' : scene_1,
		'scene_2' : scene_2,
		'scene_3' : scene_3,
		'scene_4' : scene_4,
		'scene_5' : scene_5,
		'level_1' : LEVEL_1,
		'level_2' : LEVEL_2,
		'level_3' : LEVEL_3,
		'level_4' : LEVEL_4,
		'level_5' : LEVEL_5,
		'mainScene' : mainScene,
		'pause' : pause_scene}), OptionMenu(music), Credits(), Help()), z=1)
	
	pause_scene.add(MultiplexLayer(Pause({'scene_1' : scene_1,
		'scene_2' : scene_2,
		'scene_3' : scene_3,
		'scene_4' : scene_4,
		'scene_5' : scene_5,
		'level_1' : LEVEL_1,
		'level_2' : LEVEL_2,
		'level_3' : LEVEL_3,
		'level_4' : LEVEL_4,
		'level_5' : LEVEL_5,
		'mainScene' : mainScene,
		'pause' : pause_scene}),OptionMenu2(music)), z = 1)
	
	end_game.add(GameOver(mainScene,end_game,LEVEL_5))
	
	director.run(mainScene)
