#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
    @author: Luca Paparelli
"""

import cocos
from cocos.director import director
from sys import exit
import pyglet
from cocos.menu import *
from cocos.actions import *
from cocos.text import *
from cocos.scene import *
from cocos.layer import *
from cocos.sprite import *
from pyglet import gl, font
from pyglet.window import key
from sound import *
from cocos.scenes import *

font_name = 'Vectroid'
pathatlas = 'data/'

class finalPlayer():
	def __init__(self):
		self.point = 0

class MainMenu (Menu):
	
	is_event_handler = True
	
	def __init__(self, music,args):
		super( MainMenu, self ).__init__("Mad Robot")
		
		self.scene_1 = args['scene_1']
		self.scene_2 = args['scene_2']
		self.scene_3 = args['scene_3']
		self.scene_4 = args['scene_4']
		self.scene_5 = args['scene_5']
		self.LEVEL_1 = args['level_1']
		self.LEVEL_2 = args['level_2']
		self.LEVEL_3 = args['level_3']
		self.LEVEL_4 = args['level_4']
		self.LEVEL_5 = args['level_5']
		self.mainScene = args['mainScene']
		self.pauseScene = args['pause']
		
		self.music = music
		self.music.play()
		
		self.menu_anchor_y = CENTER
		self.menu_anchor_x = CENTER
		
		self.font_title['font_name'] = "Orion Pax"
		self.font_title['font_size'] = 75
		self.font_title['color'] = (222,42,6,255)
		self.font_item['font_name'] = "Orion Pax"
		self.font_item['color'] = (222,42,6,255)
		self.font_item['font_size'] = 30
		self.font_item_selected['font_name'] = "Orion Pax"
		self.font_item_selected['color'] = (222,42,6,255)
		self.font_item_selected['font_size'] = 65

		items = []	  
		items.append(MenuItem('New Game', self.on_play, True ))
		items.append(MenuItem('Options', self.on_options, True ))
		items.append(MenuItem('Help', self.on_helps, True ))
		items.append(MenuItem('Credits', self.on_credits, True ))
		items.append(MenuItem('Quit', self.on_quit, True ))
		
		self.create_menu( items, shake(), shake_back() )
		
	def on_play(self,val):
		self.LEVEL_1.InitGame()
		self.LEVEL_2.InitGame()
		self.LEVEL_3.InitGame()
		self.LEVEL_4.InitGame()
		self.LEVEL_5.InitGame()
		image = pyglet.image.load(pathatlas+'target.png')
		self.cursor = pyglet.window.ImageMouseCursor(image, 12, 12)
		self.cursor.drawable = True
		director.window.set_mouse_cursor(self.cursor)
		music.pause()
		director.replace(FlipY3DTransition( self.scene_1,2,self.mainScene))
	
	def on_options(self,val):
		self.parent.switch_to(1)
	
	def on_quit(self,val = None):
		if val is not None :
			pyglet.app.exit()
	
	def on_credits(self, val):
		self.parent.switch_to(2)
	
	def on_helps(self, val):
		self.parent.switch_to(3)
	
class OptionMenu2(Menu):
	
	is_event_handler = True
	
	def __init__(self, music):
		super( OptionMenu2, self ).__init__("Options")
		self.music = music
		
		self.menu_anchor_y = CENTER
		self.menu_anchor_x = CENTER
		
		self.font_title['font_name'] = "Orion Pax"
		self.font_title['font_size'] = 75
		self.font_title['color'] = (222,42,6,255)
		self.font_item['font_name'] = "Orion Pax"
		self.font_item['color'] = (222,42,6,255)
		self.font_item['font_size'] = 30
		self.font_item_selected['font_name'] = "Orion Pax"
		self.font_item_selected['color'] = (222,42,6,255)
		self.font_item_selected['font_size'] = 65
		
		items = []
		items.append(MenuItem('FullScreen', self.on_fullscreen, True ))
		self.volumes = ['Mute', '10','20','30','40','50','60','70','80','90','100']
		items.append(MultipleMenuItem('Volume: ', self.on_music, self.volumes, int(self.music.getVolume() * 10)))
		items.append(MenuItem('Back', self.on_back, True ))
		
		self.create_menu( items, shake(), shake_back())
	
	def on_fullscreen(self, val):
		director.window.set_fullscreen( not director.window.fullscreen )
	
	def on_music(self, val):
		self.music.setVolume(val/10.0)
	
	def on_back(self, val):
		self.parent.switch_to(0)
	
	def on_quit(self):
		self.parent.switch_to(0)
	
class OptionMenu(Menu):
	
	is_event_handler = True
	
	def __init__(self, music):
		super( OptionMenu, self ).__init__("Options")
		self.music = music
		
		self.menu_anchor_y = CENTER
		self.menu_anchor_x = CENTER
		
		self.font_title['font_name'] = "Orion Pax"
		self.font_title['font_size'] = 75
		self.font_title['color'] = (222,42,6,255)
		self.font_item['font_name'] = "Orion Pax"
		self.font_item['color'] = (222,42,6,255)
		self.font_item['font_size'] = 30
		self.font_item_selected['font_name'] = "Orion Pax"
		self.font_item_selected['color'] = (222,42,6,255)
		self.font_item_selected['font_size'] = 65
		
		items = []
		items.append(MenuItem('FullScreen', self.on_fullscreen, True ))
		self.volumes = ['Mute', '10','20','30','40','50','60','70','80','90','100']
		items.append(MultipleMenuItem('Volume: ', self.on_music, self.volumes, int(self.music.getVolume() * 10)))
		items.append(MenuItem('Back', self.on_back, True ))
		
		self.create_menu( items, shake(), shake_back())
	
	def on_fullscreen(self, val):
		director.window.set_fullscreen( not director.window.fullscreen )
	
	def on_music(self, val):
		self.music.setVolume(val/10.0)
	
	def on_back(self, val):
		self.parent.switch_to(0)
	
	def on_quit(self):
		self.parent.switch_to(0)
	
class Credits(ColorLayer):
	
	is_event_handler = True
	
	def __init__(self):
		super(Credits, self).__init__(0,0,0,0, width=1024, height=768-80)
		
		self.font_title = {}	    
		self.font_title['font_name'] = "Orion Pax"
		self.font_title['font_size'] = 75
		self.font_title['color'] = (222,42,6,255)
		self.font_title['anchor_y'] = 'top'
		self.font_title['anchor_x'] = 'center'
		
		title = Label('Credits', **self.font_title)	   
		title.position=(1024/2.0,768)
		self.add(title,z=1)
		
		self.font_team = {}	   
		self.font_team['font_name'] = "Orion Pax"
		self.font_team['font_size'] = 60
		self.font_team['color'] = (255,116,56,255)
		self.font_team['anchor_y'] = 'top'
		self.font_team['anchor_x'] = 'center'
		
		team = Label('AGLM Team', **self.font_team)
		team.position=(350, 500)
		self.add(team,z=1)
			
		self.font_credits = {}	      
		self.font_credits['font_name'] = "Orion Pax"
		self.font_credits['font_size'] = 30
		self.font_credits['color'] = (255,116,56,255)
		self.font_credits['anchor_y'] = 'top'
		self.font_credits['anchor_x'] = 'center'
		
		credits1 = Label('TheOne', **self.font_credits)
		credits1.position=(350, 350)
		self.add(credits1,z=1)
		
		credits1 = Label('Gabriele', **self.font_credits)
		credits1.position=(350, 300)
		self.add(credits1,z=1)
		
		credits1 = Label('Soldierluca', **self.font_credits)
		credits1.position=(350, 250)
		self.add(credits1,z=1)
		
		credits1 = Label('campo23', **self.font_credits)
		credits1.position=(350, 200)
		self.add(credits1,z=1)

	def on_mouse_release( self, x, y, b, m ):
		self.parent.switch_to( 0 )
	
	def on_key_press( self, k, m ):
		if k in (key.ENTER, key.ESCAPE, key.SPACE):
			self.parent.switch_to( 0 )
			return (True)
	
class Background(Layer):
    def __init__(self):
	super(Background, self).__init__()
	bg = Sprite(pathatlas+'Robot_by_hello_big_fish.png', position=(1024/2, 768/2))
	self.add(bg, z=1)
	
class Pause(Menu):
	
	is_event_handler = True
	
	def __init__(self,args):
		super(Pause,self).__init__('Pause')
		
		self.scene_1 = args['scene_1']
		self.scene_2 = args['scene_2']
		self.scene_3 = args['scene_3']
		self.scene_4 = args['scene_4']
		self.scene_5 = args['scene_5']
		self.LEVEL_1 = args['level_1']
		self.LEVEL_2 = args['level_2']
		self.LEVEL_3 = args['level_3']
		self.LEVEL_4 = args['level_4']
		self.LEVEL_5 = args['level_5']
		self.mainScene = args['mainScene']
		self.pauseScene = args['pause']
		
		self.menu_anchor_y = CENTER
		self.menu_anchor_x = CENTER
		
		self.font_title['font_name'] = "Orion Pax"
		self.font_title['font_size'] = 75
		self.font_title['color'] = (222,42,6,255)
		self.font_item['font_name'] = "Orion Pax"
		self.font_item['color'] = (222,42,6,200)
		self.font_item['font_size'] = 30
		self.font_item_selected['font_name'] = "Orion Pax"
		self.font_item_selected['color'] = (222,42,6,255)
		self.font_item_selected['font_size'] = 65
		
		items = []
		items.append(MenuItem('Resume Game', self.on_resume, True))
		items.append(MenuItem('Option', self.on_option, True))
		items.append(MenuItem('Return to Menu', self.on_return_menu, True))
		
		self.create_menu( items, shake(), shake_back())
		
	def on_resume(self, val):
		image = pyglet.image.load(pathatlas+'target.png')
		self.cursor = pyglet.window.ImageMouseCursor(image, 12, 12)
		self.cursor.drawable = True
		director.window.set_mouse_cursor(self.cursor)
		if len(self.LEVEL_1.enemies) > 0 :
			director.replace(FlipY3DTransition( self.scene_1,0.5,self.pauseScene))
		elif len(self.LEVEL_2.enemies) > 0 :
			director.replace(FlipY3DTransition( self.scene_2,0.5,self.pauseScene))
		elif len(self.LEVEL_3.enemies) > 0 :
			director.replace(FlipY3DTransition( self.scene_3,0.5,self.pauseScene))
		elif len(self.LEVEL_4.enemies) > 0 :
			director.replace(FlipY3DTransition( self.scene_4,0.5,self.pauseScene))
		elif len(self.LEVEL_5.enemies) > 0 :
			director.replace(FlipY3DTransition( self.scene_5,0.5,self.pauseScene))
	
	def on_option(self, val):
		self.parent.switch_to(1)
	
	def on_return_menu(self, val):
		music = Sound(pathatlas+'POL-strategic-war-short.wav')
		music.play()
		director.replace(FlipY3DTransition( self.mainScene,2,self.pauseScene))

	def on_key_press( self, k, m ):
		if k == key.ESCAPE :
			image = pyglet.image.load(pathatlas+'target.png')
			self.cursor = pyglet.window.ImageMouseCursor(image, 12, 12)
			self.cursor.drawable = True
			director.window.set_mouse_cursor(self.cursor)
			if len(self.LEVEL_1.enemies) > 0 :
				director.replace(FlipY3DTransition( self.scene_1,0.5,self.pauseScene))
			elif len(self.LEVEL_2.enemies) > 0 :
				director.replace(FlipY3DTransition( self.scene_2,0.5,self.pauseScene))
			elif len(self.LEVEL_3.enemies) > 0 :
				director.replace(FlipY3DTransition( self.scene_3,0.5,self.pauseScene))
			elif len(self.LEVEL_4.enemies) > 0 :
				director.replace(FlipY3DTransition( self.scene_4,0.5,self.pauseScene))
			elif len(self.LEVEL_5.enemies) > 0 :
				director.replace(FlipY3DTransition( self.scene_5,0.5,self.pauseScene))
			return (True)
	
class Help(ColorLayer):
	
	is_event_handler = True
	
	def __init__(self):
		super(Help, self).__init__(0,0,0,0, width=1024, height=768-80)
		
		self.font_title = {}	    
		self.font_title['font_name'] = "Orion Pax"
		self.font_title['font_size'] = 75
		self.font_title['color'] = (222,42,6,255)
		self.font_title['anchor_y'] = 'top'
		self.font_title['anchor_x'] = 'center'
		
		title = Label('HELP', **self.font_title)	   
		title.position=(1024/2.0,768)
		self.add(title,z=1)
		
		self.font_team = {}	   
		self.font_team['font_name'] = "Orion Pax"
		self.font_team['font_size'] = 40
		self.font_team['color'] = (255,116,56,255)
		self.font_team['anchor_y'] = 'top'
		self.font_team['anchor_x'] = 'center'
		
		
		team = Label('-> MOVE WITH :', **self.font_team)
		team.position=(300, 530)
		self.add(team,z=1)
		
		team = Label('W+A+S+D ', **self.font_team)
		team.position=(1024/3.0+30, 450)
		self.add(team,z=1)
		
		team = Label('or', **self.font_team)
		team.position=(1024/3.0+30, 400)
		self.add(team,z=1)
		
		team = Label('Keyboard Arrows', **self.font_team)
		team.position=(1024/3.0+30, 350)
		self.add(team,z=1)
		
		team = Label('-> RELOAD WITH :', **self.font_team)
		team.position=(340, 250)
		self.add(team,z=1)
		
		team = Label('R or Right CTRL', **self.font_team)
		team.position=(1024/3.0+30, 180)
		self.add(team,z=1)
		
	
	def on_key_press( self, k, m ):
		if k in (key.ENTER, key.ESCAPE, key.SPACE):
			self.parent.switch_to( 0 )
			return (True)

	def on_mouse_release( self, x, y, b, m ):
		self.parent.switch_to( 0 )
		
class GameOver(ColorLayer):
	
	is_event_handler = True
	
	def __init__(self,mainScene,me,lastLevel):
		super(GameOver, self).__init__(0,0,0,0, width=1024, height=768-80)
		
		self.lastLevel = lastLevel
		self.mainScene = mainScene
		self.me = me
		self.font_title = {}	    
		self.font_title['font_name'] = "Orion Pax"
		self.font_title['font_size'] = 75
		self.font_title['color'] = (222,42,6,255)
		self.font_title['anchor_y'] = 'top'
		self.font_title['anchor_x'] = 'center'
		
		title = Label('END GAME', **self.font_title)	   
		title.position=(1024/2.0,768)
		self.add(title,z=1)
		
		self.font_title2 = {}
		self.font_title2['font_name'] = "Orion Pax"
		self.font_title2['font_size'] = 40
		self.font_title2['color'] = (222,42,6,255)
		self.font_title2['anchor_y'] = 'top'
		self.font_title2['anchor_x'] = 'center'
		
		nome_team = Label('Your Score', **self.font_title2)	      
		nome_team.position=(1024/2.0,550)
		self.add(nome_team,z=1)
		
		self.component = Label('-> 0 <-', **self.font_title2)	    
		self.component.position=(1024/2.0,400)
		self.add(self.component,z=1)
		
		self.player = finalPlayer()

	def on_mouse_release( self, x, y, b, m ):
		director.replace(ShuffleTransition( self.mainScene,2,self.me))
		music = Sound(pathatlas+'POL-strategic-war-short.wav')
		music.play()
		director.replace(ShuffleTransition( self.mainScene,2,self.me))
		return(True)
	
	def on_key_press( self, k, m ):
		if k == key.ESCAPE :
			music = Sound(pathatlas+'POL-strategic-war-short.wav')
			music.play()
			director.replace(ShuffleTransition( self.mainScene,2,self.me))
			return(True)