#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
	@author: Luca Paparelli
"""

import cocos
from cocos.audio.pygame import *
from cocos.audio.effect import *

class Sound():
	def __init__(self, name_music):
		mixer.init()
		music.load(name_music)
		music.set_volume(1)

	def play(self):
		if(not music.get_busy()) :
			music.play(loops=-1, start=0.0)

	def pause(self):
		music.stop()

	def setVolume(self, vol):
		music.set_volume(vol)

	def getVolume(self):
		return music.get_volume()

class Effects():
	def __init__(self, effects_list):
		self.effects_list = effects_list
		mixer.init()
		self.effects = {}
		self.effects['shot'] = Effect(self.effects_list['shot'])

	def play(self, effect):
		self.effects[effect].play()